import os

# A storage initializer downloads the assets from Asset Storage to assets directory
# On a remote host ASSET_DIR is /mnt/models
ASSET_DIR = os.getenv("ASSET_DIR", ".")

# ASSET_URI is generated by aiXplain's asset store.
ASSET_URI = os.getenv("ASSET_URI", "asset")

class AssetResolver():
    def __init__(self) -> None:
        self._asset_uri = ASSET_URI

    @staticmethod
    def resolve_path():
        asset_path = os.path.join(ASSET_DIR, ASSET_URI)
        return asset_path

    @staticmethod
    def asset_uri():
        return ASSET_URI